package de.twomartens.oparlservice;

import lombok.extern.slf4j.Slf4j;
import org.springframework.boot.SpringApplication;
import org.springframework.boot.autoconfigure.SpringBootApplication;
import org.springframework.scheduling.annotation.EnableScheduling;

import java.util.Optional;

@Slf4j
@SpringBootApplication
@EnableScheduling
public class OParlServiceApplication {

    public static void main(String[] args) {
        log.info(">>> {}:{} <<<", getTitle(), getVersion());
        SpringApplication.run(OParlServiceApplication.class, args);
    }

    private static String getTitle() {
        return Optional.ofNullable(OParlServiceApplication.class.getPackage().getImplementationTitle())
                .orElse("start");
    }

    private static String getVersion() {
        return Optional.ofNullable(OParlServiceApplication.class.getPackage().getImplementationVersion())
                .orElse("snapshot");
    }
}
