package de.twomartens.oparlservice.entity.dto;

import com.fasterxml.jackson.annotation.JsonInclude;
import io.swagger.v3.oas.annotations.media.Schema;
import lombok.*;

@Builder
@Getter
@ToString
@EqualsAndHashCode
@AllArgsConstructor(access = AccessLevel.PRIVATE)
@NoArgsConstructor(force = true, access = AccessLevel.PRIVATE)
@JsonInclude(JsonInclude.Include.NON_NULL)
public class Links {
    @Schema(description = "URL to the first list page")
    private final String first;

    @Schema(description = "URL to the previous list page")
    private final String prev;

    @Schema(description = "canonical URL for the current list page")
    private final String self;

    @Schema(description = "URL to the next list page", required = true)
    private final String next;

    @Schema(description = "URL to the last list page")
    private final String last;

    @Schema(description = "URL of a website that presents the object in the browser")
    private String web;
}
