package de.twomartens.oparlservice.service;

import de.twomartens.oparlservice.configs.OParlServiceProperties;
import de.twomartens.oparlservice.entity.dto.System;
import de.twomartens.oparlservice.entity.dto.*;
import de.twomartens.oparlservice.repository.SystemRepository;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.time.ZonedDateTime;
import java.util.Collections;
import java.util.Optional;
import java.util.stream.StreamSupport;

@Service
public class OParlService {

    private final OParlServiceProperties properties;
    private final SystemRepository systemRepository;

    @Autowired
    public OParlService(OParlServiceProperties properties, SystemRepository systemRepository) {
        this.properties = properties;
        this.systemRepository = systemRepository;
    }

    public Optional<ObjectList<AgendaItem>> getAgendaItemsInBody(String bodyID, int pageNumber) {
        return Optional.empty();
    }

    public Optional<AgendaItem> getAgendaItem(String id) {
        return Optional.empty();
    }

    public ObjectList<Body> getBodies() {
        return null;
    }

    public Optional<Body> getBody(String id) {
        return Optional.empty();
    }

    public Optional<ObjectList<Consultation>> getConsultationsInBody(String bodyID, int pageNumber) {
        return Optional.empty();
    }

    public Optional<Consultation> getConsultation(String id) {
        return Optional.empty();
    }

    public Optional<ObjectList<File>> getFilesInBody(String bodyID, int pageNumber) {
        return Optional.empty();
    }

    public Optional<File> getFile(String id) {
        return Optional.empty();
    }

    public Optional<ObjectList<LegislativeTerm>> getLegislativeTermsOfBody(String bodyID, int pageNumber) {
        return Optional.empty();
    }

    public Optional<LegislativeTerm> getLegislativeTerm(String id) {
        return Optional.empty();
    }

    public Optional<ObjectList<Location>> getLocationsInBody(String bodyID, int pageNumber) {
        return Optional.empty();
    }

    public Optional<Location> getLocation(String id) {
        return Optional.empty();
    }

    public Optional<Meeting> getMeeting(String id) {
        return Optional.empty();
    }

    public Optional<ObjectList<Meeting>> getMeetingsInBody(String bodyID, int pageNumber) {
        return Optional.empty();
    }

    public Optional<ObjectList<Meeting>> getMeetingsInOrganization(String organizationID, int pageNumber) {
        return Optional.empty();
    }

    public Optional<Membership> getMembership(String id) {
        return Optional.empty();
    }

    public Optional<ObjectList<Membership>> getMembershipsInBody(String bodyID, int pageNumber) {
        return Optional.empty();
    }

    public Optional<ObjectList<Membership>> getMembershipsInOrganization(String organizationID, int pageNumber) {
        return Optional.empty();
    }

    public Optional<ObjectList<Organization>> getOrganizationsInBody(String bodyID, int pageNumber) {
        return Optional.empty();
    }

    public Optional<Organization> getOrganization(String id) {
        return Optional.empty();
    }

    public Optional<ObjectList<Paper>> getPapersInBody(String bodyID, int pageNumber) {
        return Optional.empty();
    }

    public Optional<Paper> getPaper(String id) {
        return Optional.empty();
    }

    public Optional<ObjectList<Person>> getPersonsInBody(String bodyID, int pageNumber) {
        return Optional.empty();
    }

    public Optional<Person> getPerson(String id) {
        return Optional.empty();
    }

    public System getSystem() {
        Iterable<de.twomartens.oparlservice.entity.internal.System> systems = systemRepository.findAll();
        Optional<de.twomartens.oparlservice.entity.internal.System> firstNotDeletedSystem = StreamSupport
            .stream(systems.spliterator(), false)
            .filter(system -> !system.isDeleted())
            .findFirst();

        de.twomartens.oparlservice.entity.internal.System system;
        if (firstNotDeletedSystem.isEmpty()) {
            de.twomartens.oparlservice.entity.internal.System newSystem = new de.twomartens.oparlservice.entity.internal.System();
            newSystem.setCreated(ZonedDateTime.now());
            newSystem.setModified(ZonedDateTime.now());
            newSystem.setDeleted(false);
            system = systemRepository.saveAndFlush(newSystem);
        } else {
            system = firstNotDeletedSystem.get();
        }

        return System.builder()
            .id(String.valueOf(system.getId()))
            .type("https://schema.oparl.org/1.1/Schema")
            .created(system.getCreated())
            .modified(system.getModified())
            .oparlVersion("https://schema.oparl.org/1.1/")
            .body(properties.getUrl() + "/bodies")
            .license(system.getLicense())
            .name(system.getName())
            .contactEmail(system.getContactEmail())
            .contactName(system.getContactName())
            .deleted(system.isDeleted())
            .product(system.getProduct())
            .vendor(system.getVendor())
            .web(system.getWeb())
            .website(system.getWebsite())
            .otherOparlVersions(Collections.emptyList())
            .build();
    }
}
